#if !defined(SDR14X_TOOLS)
#define SDR14X_TOOLS
//////////////////////////////////////////////////////////////////////
// Copyright 2003.    Moe Wheatley AE4JY  <http://www.moetronix.com>
//
//This program is free software; you can redistribute it and/or
//modify it how ever you wish.  Its primary goal is to provide an
// example for 3rd party software developers.  Support will be limited
// depending on my available time.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
////////////////////////////////////////////////////////////////////////

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// SDR14XCtl.h : Declaration of the sdr14ctrl ActiveX Control class.

#include "SDR14USBio.h"
#include "SDR14ascpDefs.h"	//local copy of ASCP defs

#define MSG_DATARDY 1000	//local user messages for event firing
#define MSG_STATUSCHNG 1001
#define MSG_AUXDATARDY 1002

#define STATUS_NOTCONNECTED 0	//SDR-14,IQ status codes
#define STATUS_IDLECONNECTED 1
#define STATUS_RUNNING 2
#define STATUS_ERROR 3
#define STATUS_ADOVERLOAD 4		//IQ only

#define STATUS_RADIO_NOTCONNECTED	1	//SDR-14,IQ status codes - my Bonito Radio Flags
#define STATUS_RADIO_IDLECONNECTED	2
#define STATUS_RADIO_RUNNING		4
#define STATUS_RADIO_ERROR			8
#define STATUS_RADIO_ADOVERLOAD		16	//IQ only

#define AUX_QUE_LENGTH 1024		//keep power of 2 for modulo wrap around
#define AUX_QUE_MODMASK (AUX_QUE_LENGTH-1)

#define SDRTYPE_14 0
#define SDRTYPE_IQ 1

//(dec) 9-Oct-04 Uncomment this to fix the OLEMISC_INVISIBLEATRUNTIME problem with VB
#define	OLEMISC_INVISIBLEATRUNTIME_FIX


//////////////////////////////////////////////////////////////////////////////
// The following creates a bunch of global pointers to all the FTDI driver
// dll functions
//////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// sdr14ctrl : See SDR14XCtl.cpp for implementation.

class sdr14ctrl : public sdr14USBio
{

// Constructor
public:
			sdr14ctrl();
virtual		~sdr14ctrl();

public:


	void		Exit();
	void		InitControl();
	void		SetClockFrequency(long nNewValue);
	void		SetHFgain(short nNewValue);
	void		SetIFfilter(short nNewValue);
	void		SetInputSource(short nNewValue);
	void		SetNCOfrequency(long nNewValue);
	void		SetIFgain(short nNewValue);
	void		SetSampleRate(long nNewValue);
	
	void		Stop();
	void		Start(short Blocks, short Mode);
	void		Send6620RawCmd(short Address, short D0, short D1, short D2, short D3, short D4);
	void		ClearVariables();

	int			m_ModifiedFlag;
	void		SetModifiedFlag(BOOL flag=TRUE){m_ModifiedFlag=flag;}
	BOOL		IsModified() {return m_ModifiedFlag;}

	// need to be public for USB thread access
	int			m_ThreadRunning;
	int			m_SDRtype;
	CWinThread	*m_pUSBThread;
	CWinThread	*m_pFIFOThread;
	void		ParseASCPmsg(ASCPstruct* pASCPmsg);
	void		ErrorStop();
	float		dBcorr;


// internal helper functions
	static		UINT USBThreadProc(LPVOID pParam);	//must be static since is thread
	static		UINT FIFOThreadProc(LPVOID pParam);	//must be static since is thread
	void		EndThreads();
	void		SetupDataBuffers( int blocks);
	double		CalcOffsetIQ();
	void		ReadSDRIQClockFrequency();
	void		WriteSDRIQClockFrequency();
//  property variables
	short		m_BootRevision;
	short		m_FirmwareRevision;
	short		m_HFgain;	
	short		m_InterfaceVersion;
	short		m_IFfilter;
	short		m_IFgain;
	short		m_InputSource;
	short		m_TestModeChannel;
	long		m_NCOfrequency;
	long		m_ClockFrequency;
	long		m_SampleRate;
	double		m_IQOffset;
	CString		m_DeviceName;
	CString		m_SerialNumber;
//	local variables
	BOOL		m_Complex;		//whether data is complex or real
	BOOL		m_ADOverload;
	short		m_CaptureMode;
	int			m_RCFTaps;
	int			m_BlockCount;
	int			m_NumberOfBlocks;
	int			m_DataAckCounter;
	int			m_DataAckCounterLoadVal;
	int			m_WindowsMsgCount;		//keep track of how many data msgs were sent and not responded to

	short**		m_pDataBuffer;
	int			m_FifoHead;
	int			m_FifoTail;
	int			m_FifoFFTTail;
	int			m_LastStatus;
	ASCPstruct	m_ASCPmsg;
	ASCPstruct	m_ASCPackmsg;
	CRITICAL_SECTION m_CriticalSection;	//for keeping threads from stomping on each other

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(SDR14X_TOOLS)
