#include "stdafx.h"
#include "sdr14dll.h"
#include "../GlobalTools.h"
#include "../ExtIOFunktions.h"

sdr14dll::sdr14dll()
{
	IsRunning=0;
	lastMode=-1;
}

sdr14dll::~sdr14dll()	
{
	CloseExtRx();
}

BOOL sdr14dll::OpenExtRx()
{	
	int ret=0;
	m_SDRtype = SDRTYPE_IQ;
	//else m_SDRtype = SDRTYPE_14;

	CloseExtRx();
	if(!OpenUSBdll()) return FALSE;

	InitControl();
	SetInputSource(0x81); //HF AD6620 0x01=Real //0x81=Complex mode
	SetATT(myPara.ATT);
	_Set_IFGain(myPara.IFGain);
	_Set_HFGain(myPara.HFGain);
	return SetSampleMode(myPara.mode);
}

BOOL sdr14dll::SetSampleMode(int mode)
{
	if(h_FTlib<0) return FALSE;
	if(lastMode==mode) return TRUE;
	int	bIsRunning=IsRunning;
	if(bIsRunning) CodecStop();
	SetSampleWidth(mode);
	if(bIsRunning) CodecStart();

	if(extIOCallback) 
		{
		extIOCallback(-1,100,0,0); // tells the ExtIQ-APP, that the sampling frequency was changed
		}
	lastMode=mode;

	return TRUE;
}

BOOL sdr14dll::SetSampleWidth(int mode)
{
	if(h_FTlib<0) return FALSE;

	if(mode>12) mode=12;
	if(mode<0) mode=0;
	if(m_SDRtype==SDRTYPE_IQ && mode>2)  mode=2;
	myPara.mode=mode;
	switch(myPara.mode)
		{
		case	0:	 IQ_freq=55555;		IQ_spow=12;		LastBW=3;	break; 
		case	1:	 IQ_freq=111111;	IQ_spow=12;		LastBW=4;	break; 
		default:
		case	2:	 IQ_freq=196078;	IQ_spow=13;		LastBW=12;	break;
		case	3:	 IQ_freq=574713;	IQ_spow=14;		LastBW=7;	break; 
		case	4:	 IQ_freq=1282051;	IQ_spow=15;		LastBW=8;	break; 
		}

	IQ_spow=12;
	SetIFfilter(LastBW);
	return TRUE;
}

void sdr14dll::CloseExtRx()
{
	if(h_FTlib) 
		{
		CodecStop();
		Sleep(0);
		Exit();
		}
}

int sdr14dll::SetFrequency(int freq)
{
	long nNewValue=freq;

	if(h_FTlib)
		{
		lastFrq=freq;
		if(nNewValue<10) nNewValue=10;
		if(nNewValue>38000000) nNewValue=38000000;
		if(m_NCOfrequency!=nNewValue) SetNCOfrequency(nNewValue);
		}
	return freq;
}

void sdr14dll::SetATT(int att)
{
	if(h_FTlib)
		{
		int gain=myPara.HFGain;
		if(att) gain+=20;
		if(gain>30) gain=30;
		SetHFgain(-gain); 
		}
}

void sdr14dll::_Set_IFGain(int gain)
{
	if(h_FTlib)
		{
		SetIFgain(gain); 
		}
}

void sdr14dll::_Set_HFGain(int gain)
{
	if(h_FTlib)
		{
		if(myPara.ATT) gain+=20;
		if(gain>30) gain=30;
		SetHFgain(-gain); 
		}
}


BOOL sdr14dll::CodecStart()
{
	if (!h_FTlib) return FALSE;
	Start(2,0);
	IsRunning=1;
	return  TRUE;
}

BOOL sdr14dll::CodecStop()
{
	if (!h_FTlib) return NULL;
	Stop();
	IsRunning=0;
	return TRUE;
}

